#include "bit.h"

/* definition */
typedef enum
{
	CHEV_ARIA_128 = 0,
	CHEV_ARIA_192,
	CHEV_ARIA_256
} CHEV_ARIA_TYPE;

typedef struct
{
	CHEV_ARIA_TYPE	type;
	int				round;
	byte			ek[17][16 /* 128-bits */];
	byte			dk[17][16 /* 128-bits */];
} CHEV_ARIA_INFO;

#ifdef __cplusplus
extern "C" {
#endif

/* function */
int
CHEV_ARIA_Initialize	(CHEV_ARIA_INFO	* info,
						 CHEV_ARIA_TYPE	type,
						 byte			* inputKey,
						 int			keySize);

int
CHEV_ARIA_Encrypt		(CHEV_ARIA_INFO	* info,
						 byte			* input,
						 int			inSize,
						 byte			* out,
						 int			* outSize);

int
CHEV_ARIA_Decrypt		(CHEV_ARIA_INFO	* info,
						 byte			* input,
						 int			inSize,
						 byte			* out,
						 int			* outSize);

#ifdef __cplusplus
}
#endif
